import { ScaleType } from '../../scale';
import { keys } from '../../util';
import { formatSignalRef } from '../format';
export function labels(model, channel, specifiedLabelsSpec) {
    var _a;
    const fieldDef = (_a = model.fieldDef(channel)) !== null && _a !== void 0 ? _a : (channel === 'x' ? model.fieldDef('x2') : channel === 'y' ? model.fieldDef('y2') : undefined);
    const axis = model.axis(channel);
    const { format, formatType } = axis;
    const { config } = model;
    const text = formatSignalRef({
        fieldDef,
        field: 'datum.value',
        format,
        formatType,
        config,
        isUTCScale: model.getScaleComponent(channel).get('type') === ScaleType.UTC,
        omitTimeFormatConfig: true,
        omitNumberFormatAndEmptyTimeFormat: true // no need to generate number format for encoding block as we can use Vega's axis format
    });
    let labelsSpec = Object.assign(Object.assign({}, (text ? { text } : {})), specifiedLabelsSpec);
    labelsSpec = Object.assign(Object.assign({}, labelsSpec), specifiedLabelsSpec);
    return keys(labelsSpec).length === 0 ? undefined : labelsSpec;
}
//# sourceMappingURL=encode.js.map